/*
*
* CwBdManualSerialExample.java
* Copyright(C) 2017-2020 DHCC
* @date 2020-06-04
*/
package com.dhcc.finance.main.domain;

import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.Date;
import java.util.Iterator;
import java.util.List;

public class CwBdManualSerialExample {
    /**
     * cw_bd_manual_serial
     */
    protected String orderByClause;

    /**
     * cw_bd_manual_serial
     */
    protected boolean distinct;

    /**
     * cw_bd_manual_serial
     */
    protected List<Criteria> oredCriteria;

    /**
     *
     * @mbg.generated 2020-06-04
     */
    public CwBdManualSerialExample() {
        oredCriteria = new ArrayList<Criteria>();
    }

    /**
     *
     * @mbg.generated 2020-06-04
     */
    public void setOrderByClause(String orderByClause) {
        this.orderByClause = orderByClause;
    }

    /**
     *
     * @mbg.generated 2020-06-04
     */
    public String getOrderByClause() {
        return orderByClause;
    }

    /**
     *
     * @mbg.generated 2020-06-04
     */
    public void setDistinct(boolean distinct) {
        this.distinct = distinct;
    }

    /**
     *
     * @mbg.generated 2020-06-04
     */
    public boolean isDistinct() {
        return distinct;
    }

    /**
     *
     * @mbg.generated 2020-06-04
     */
    public List<Criteria> getOredCriteria() {
        return oredCriteria;
    }

    /**
     *
     * @mbg.generated 2020-06-04
     */
    public void or(Criteria criteria) {
        oredCriteria.add(criteria);
    }

    /**
     *
     * @mbg.generated 2020-06-04
     */
    public Criteria or() {
        Criteria criteria = createCriteriaInternal();
        oredCriteria.add(criteria);
        return criteria;
    }

    /**
     *
     * @mbg.generated 2020-06-04
     */
    public Criteria createCriteria() {
        Criteria criteria = createCriteriaInternal();
        if (oredCriteria.size() == 0) {
            oredCriteria.add(criteria);
        }
        return criteria;
    }

    /**
     *
     * @mbg.generated 2020-06-04
     */
    protected Criteria createCriteriaInternal() {
        Criteria criteria = new Criteria();
        return criteria;
    }

    /**
     *
     * @mbg.generated 2020-06-04
     */
    public void clear() {
        oredCriteria.clear();
        orderByClause = null;
        distinct = false;
    }

    /**
     * cw_bd_manual_serial 2020-06-04
     */
    protected abstract static class GeneratedCriteria {
        protected List<Criterion> criteria;

        protected GeneratedCriteria() {
            super();
            criteria = new ArrayList<Criterion>();
        }

        public boolean isValid() {
            return criteria.size() > 0;
        }

        public List<Criterion> getAllCriteria() {
            return criteria;
        }

        public List<Criterion> getCriteria() {
            return criteria;
        }

        protected void addCriterion(String condition) {
            if (condition == null) {
                throw new RuntimeException("Value for condition cannot be null");
            }
            criteria.add(new Criterion(condition));
        }

        protected void addCriterion(String condition, Object value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value));
        }

        protected void addCriterion(String condition, Object value1, Object value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            criteria.add(new Criterion(condition, value1, value2));
        }

        protected void addCriterionForJDBCDate(String condition, Date value, String property) {
            if (value == null) {
                throw new RuntimeException("Value for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value.getTime()), property);
        }

        protected void addCriterionForJDBCDate(String condition, List<Date> values, String property) {
            if (values == null || values.size() == 0) {
                throw new RuntimeException("Value list for " + property + " cannot be null or empty");
            }
            List<java.sql.Date> dateList = new ArrayList<java.sql.Date>();
            Iterator<Date> iter = values.iterator();
            while (iter.hasNext()) {
                dateList.add(new java.sql.Date(iter.next().getTime()));
            }
            addCriterion(condition, dateList, property);
        }

        protected void addCriterionForJDBCDate(String condition, Date value1, Date value2, String property) {
            if (value1 == null || value2 == null) {
                throw new RuntimeException("Between values for " + property + " cannot be null");
            }
            addCriterion(condition, new java.sql.Date(value1.getTime()), new java.sql.Date(value2.getTime()), property);
        }

        public Criteria andIdIsNull() {
            addCriterion("ID is null");
            return (Criteria) this;
        }

        public Criteria andIdIsNotNull() {
            addCriterion("ID is not null");
            return (Criteria) this;
        }

        public Criteria andIdEqualTo(String value) {
            addCriterion("ID =", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotEqualTo(String value) {
            addCriterion("ID <>", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThan(String value) {
            addCriterion("ID >", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdGreaterThanOrEqualTo(String value) {
            addCriterion("ID >=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThan(String value) {
            addCriterion("ID <", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLessThanOrEqualTo(String value) {
            addCriterion("ID <=", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdLike(String value) {
            addCriterion("ID like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotLike(String value) {
            addCriterion("ID not like", value, "id");
            return (Criteria) this;
        }

        public Criteria andIdIn(List<String> values) {
            addCriterion("ID in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotIn(List<String> values) {
            addCriterion("ID not in", values, "id");
            return (Criteria) this;
        }

        public Criteria andIdBetween(String value1, String value2) {
            addCriterion("ID between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andIdNotBetween(String value1, String value2) {
            addCriterion("ID not between", value1, value2, "id");
            return (Criteria) this;
        }

        public Criteria andBatchNoIsNull() {
            addCriterion("BATCH_NO is null");
            return (Criteria) this;
        }

        public Criteria andBatchNoIsNotNull() {
            addCriterion("BATCH_NO is not null");
            return (Criteria) this;
        }

        public Criteria andBatchNoEqualTo(String value) {
            addCriterion("BATCH_NO =", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoNotEqualTo(String value) {
            addCriterion("BATCH_NO <>", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoGreaterThan(String value) {
            addCriterion("BATCH_NO >", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoGreaterThanOrEqualTo(String value) {
            addCriterion("BATCH_NO >=", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoLessThan(String value) {
            addCriterion("BATCH_NO <", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoLessThanOrEqualTo(String value) {
            addCriterion("BATCH_NO <=", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoLike(String value) {
            addCriterion("BATCH_NO like", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoNotLike(String value) {
            addCriterion("BATCH_NO not like", value, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoIn(List<String> values) {
            addCriterion("BATCH_NO in", values, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoNotIn(List<String> values) {
            addCriterion("BATCH_NO not in", values, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoBetween(String value1, String value2) {
            addCriterion("BATCH_NO between", value1, value2, "batchNo");
            return (Criteria) this;
        }

        public Criteria andBatchNoNotBetween(String value1, String value2) {
            addCriterion("BATCH_NO not between", value1, value2, "batchNo");
            return (Criteria) this;
        }

        public Criteria andProjectCodeIsNull() {
            addCriterion("PROJECT_CODE is null");
            return (Criteria) this;
        }

        public Criteria andProjectCodeIsNotNull() {
            addCriterion("PROJECT_CODE is not null");
            return (Criteria) this;
        }

        public Criteria andProjectCodeEqualTo(String value) {
            addCriterion("PROJECT_CODE =", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andProjectCodeNotEqualTo(String value) {
            addCriterion("PROJECT_CODE <>", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andProjectCodeGreaterThan(String value) {
            addCriterion("PROJECT_CODE >", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andProjectCodeGreaterThanOrEqualTo(String value) {
            addCriterion("PROJECT_CODE >=", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andProjectCodeLessThan(String value) {
            addCriterion("PROJECT_CODE <", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andProjectCodeLessThanOrEqualTo(String value) {
            addCriterion("PROJECT_CODE <=", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andProjectCodeLike(String value) {
            addCriterion("PROJECT_CODE like", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andProjectCodeNotLike(String value) {
            addCriterion("PROJECT_CODE not like", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andProjectCodeIn(List<String> values) {
            addCriterion("PROJECT_CODE in", values, "projectCode");
            return (Criteria) this;
        }

        public Criteria andProjectCodeNotIn(List<String> values) {
            addCriterion("PROJECT_CODE not in", values, "projectCode");
            return (Criteria) this;
        }

        public Criteria andProjectCodeBetween(String value1, String value2) {
            addCriterion("PROJECT_CODE between", value1, value2, "projectCode");
            return (Criteria) this;
        }

        public Criteria andProjectCodeNotBetween(String value1, String value2) {
            addCriterion("PROJECT_CODE not between", value1, value2, "projectCode");
            return (Criteria) this;
        }

        public Criteria andProjectNameIsNull() {
            addCriterion("PROJECT_NAME is null");
            return (Criteria) this;
        }

        public Criteria andProjectNameIsNotNull() {
            addCriterion("PROJECT_NAME is not null");
            return (Criteria) this;
        }

        public Criteria andProjectNameEqualTo(String value) {
            addCriterion("PROJECT_NAME =", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andProjectNameNotEqualTo(String value) {
            addCriterion("PROJECT_NAME <>", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andProjectNameGreaterThan(String value) {
            addCriterion("PROJECT_NAME >", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andProjectNameGreaterThanOrEqualTo(String value) {
            addCriterion("PROJECT_NAME >=", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andProjectNameLessThan(String value) {
            addCriterion("PROJECT_NAME <", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andProjectNameLessThanOrEqualTo(String value) {
            addCriterion("PROJECT_NAME <=", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andProjectNameLike(String value) {
            addCriterion("PROJECT_NAME like", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andProjectNameNotLike(String value) {
            addCriterion("PROJECT_NAME not like", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andProjectNameIn(List<String> values) {
            addCriterion("PROJECT_NAME in", values, "projectName");
            return (Criteria) this;
        }

        public Criteria andProjectNameNotIn(List<String> values) {
            addCriterion("PROJECT_NAME not in", values, "projectName");
            return (Criteria) this;
        }

        public Criteria andProjectNameBetween(String value1, String value2) {
            addCriterion("PROJECT_NAME between", value1, value2, "projectName");
            return (Criteria) this;
        }

        public Criteria andProjectNameNotBetween(String value1, String value2) {
            addCriterion("PROJECT_NAME not between", value1, value2, "projectName");
            return (Criteria) this;
        }

        public Criteria andSubProjectCodeIsNull() {
            addCriterion("SUB_PROJECT_CODE is null");
            return (Criteria) this;
        }

        public Criteria andSubProjectCodeIsNotNull() {
            addCriterion("SUB_PROJECT_CODE is not null");
            return (Criteria) this;
        }

        public Criteria andSubProjectCodeEqualTo(String value) {
            addCriterion("SUB_PROJECT_CODE =", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andSubProjectCodeNotEqualTo(String value) {
            addCriterion("SUB_PROJECT_CODE <>", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andSubProjectCodeGreaterThan(String value) {
            addCriterion("SUB_PROJECT_CODE >", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andSubProjectCodeGreaterThanOrEqualTo(String value) {
            addCriterion("SUB_PROJECT_CODE >=", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andSubProjectCodeLessThan(String value) {
            addCriterion("SUB_PROJECT_CODE <", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andSubProjectCodeLessThanOrEqualTo(String value) {
            addCriterion("SUB_PROJECT_CODE <=", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andSubProjectCodeLike(String value) {
            addCriterion("SUB_PROJECT_CODE like", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andSubProjectCodeNotLike(String value) {
            addCriterion("SUB_PROJECT_CODE not like", value, "projectCode");
            return (Criteria) this;
        }

        public Criteria andSubProjectCodeIn(List<String> values) {
            addCriterion("SUB_PROJECT_CODE in", values, "projectCode");
            return (Criteria) this;
        }

        public Criteria andSubProjectCodeNotIn(List<String> values) {
            addCriterion("SUB_PROJECT_CODE not in", values, "projectCode");
            return (Criteria) this;
        }

        public Criteria andSubProjectCodeBetween(String value1, String value2) {
            addCriterion("SUB_PROJECT_CODE between", value1, value2, "projectCode");
            return (Criteria) this;
        }

        public Criteria andSubProjectCodeNotBetween(String value1, String value2) {
            addCriterion("SUB_PROJECT_CODE not between", value1, value2, "projectCode");
            return (Criteria) this;
        }

        public Criteria andSubProjectNameIsNull() {
            addCriterion("SUB_PROJECT_NAME is null");
            return (Criteria) this;
        }

        public Criteria andSubProjectNameIsNotNull() {
            addCriterion("SUB_PROJECT_NAME is not null");
            return (Criteria) this;
        }

        public Criteria andSubProjectNameEqualTo(String value) {
            addCriterion("SUB_PROJECT_NAME =", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andSubProjectNameNotEqualTo(String value) {
            addCriterion("SUB_PROJECT_NAME <>", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andSubProjectNameGreaterThan(String value) {
            addCriterion("SUB_PROJECT_NAME >", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andSubProjectNameGreaterThanOrEqualTo(String value) {
            addCriterion("SUB_PROJECT_NAME >=", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andSubProjectNameLessThan(String value) {
            addCriterion("SUB_PROJECT_NAME <", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andSubProjectNameLessThanOrEqualTo(String value) {
            addCriterion("SUB_PROJECT_NAME <=", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andSubProjectNameLike(String value) {
            addCriterion("SUB_PROJECT_NAME like", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andSubProjectNameNotLike(String value) {
            addCriterion("SUB_PROJECT_NAME not like", value, "projectName");
            return (Criteria) this;
        }

        public Criteria andSubProjectNameIn(List<String> values) {
            addCriterion("SUB_PROJECT_NAME in", values, "projectName");
            return (Criteria) this;
        }

        public Criteria andSubProjectNameNotIn(List<String> values) {
            addCriterion("SUB_PROJECT_NAME not in", values, "projectName");
            return (Criteria) this;
        }

        public Criteria andSubProjectNameBetween(String value1, String value2) {
            addCriterion("SUB_PROJECT_NAME between", value1, value2, "projectName");
            return (Criteria) this;
        }

        public Criteria andSubProjectNameNotBetween(String value1, String value2) {
            addCriterion("SUB_PROJECT_NAME not between", value1, value2, "projectName");
            return (Criteria) this;
        }

        public Criteria andSubjcodeIsNull() {
            addCriterion("SUBJCODE is null");
            return (Criteria) this;
        }

        public Criteria andSubjcodeIsNotNull() {
            addCriterion("SUBJCODE is not null");
            return (Criteria) this;
        }

        public Criteria andSubjcodeEqualTo(String value) {
            addCriterion("SUBJCODE =", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotEqualTo(String value) {
            addCriterion("SUBJCODE <>", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeGreaterThan(String value) {
            addCriterion("SUBJCODE >", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeGreaterThanOrEqualTo(String value) {
            addCriterion("SUBJCODE >=", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeLessThan(String value) {
            addCriterion("SUBJCODE <", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeLessThanOrEqualTo(String value) {
            addCriterion("SUBJCODE <=", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeLike(String value) {
            addCriterion("SUBJCODE like", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotLike(String value) {
            addCriterion("SUBJCODE not like", value, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeIn(List<String> values) {
            addCriterion("SUBJCODE in", values, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotIn(List<String> values) {
            addCriterion("SUBJCODE not in", values, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeBetween(String value1, String value2) {
            addCriterion("SUBJCODE between", value1, value2, "subjcode");
            return (Criteria) this;
        }

        public Criteria andSubjcodeNotBetween(String value1, String value2) {
            addCriterion("SUBJCODE not between", value1, value2, "subjcode");
            return (Criteria) this;
        }

        public Criteria andVoucherTypeIsNull() {
            addCriterion("VOUCHER_TYPE is null");
            return (Criteria) this;
        }

        public Criteria andVoucherTypeIsNotNull() {
            addCriterion("VOUCHER_TYPE is not null");
            return (Criteria) this;
        }

        public Criteria andVoucherTypeEqualTo(String value) {
            addCriterion("VOUCHER_TYPE =", value, "voucherType");
            return (Criteria) this;
        }

        public Criteria andVoucherTypeNotEqualTo(String value) {
            addCriterion("VOUCHER_TYPE <>", value, "voucherType");
            return (Criteria) this;
        }

        public Criteria andVoucherTypeGreaterThan(String value) {
            addCriterion("VOUCHER_TYPE >", value, "voucherType");
            return (Criteria) this;
        }

        public Criteria andVoucherTypeGreaterThanOrEqualTo(String value) {
            addCriterion("VOUCHER_TYPE >=", value, "voucherType");
            return (Criteria) this;
        }

        public Criteria andVoucherTypeLessThan(String value) {
            addCriterion("VOUCHER_TYPE <", value, "voucherType");
            return (Criteria) this;
        }

        public Criteria andVoucherTypeLessThanOrEqualTo(String value) {
            addCriterion("VOUCHER_TYPE <=", value, "voucherType");
            return (Criteria) this;
        }

        public Criteria andVoucherTypeLike(String value) {
            addCriterion("VOUCHER_TYPE like", value, "voucherType");
            return (Criteria) this;
        }

        public Criteria andVoucherTypeNotLike(String value) {
            addCriterion("VOUCHER_TYPE not like", value, "voucherType");
            return (Criteria) this;
        }

        public Criteria andVoucherTypeIn(List<String> values) {
            addCriterion("VOUCHER_TYPE in", values, "voucherType");
            return (Criteria) this;
        }

        public Criteria andVoucherTypeNotIn(List<String> values) {
            addCriterion("VOUCHER_TYPE not in", values, "voucherType");
            return (Criteria) this;
        }

        public Criteria andVoucherTypeBetween(String value1, String value2) {
            addCriterion("VOUCHER_TYPE between", value1, value2, "voucherType");
            return (Criteria) this;
        }

        public Criteria andVoucherTypeNotBetween(String value1, String value2) {
            addCriterion("VOUCHER_TYPE not between", value1, value2, "voucherType");
            return (Criteria) this;
        }

        public Criteria andVoucherAmountIsNull() {
            addCriterion("VOUCHER_AMOUNT is null");
            return (Criteria) this;
        }

        public Criteria andVoucherAmountIsNotNull() {
            addCriterion("VOUCHER_AMOUNT is not null");
            return (Criteria) this;
        }

        public Criteria andVoucherAmountEqualTo(BigDecimal value) {
            addCriterion("VOUCHER_AMOUNT =", value, "voucherAmount");
            return (Criteria) this;
        }

        public Criteria andVoucherAmountNotEqualTo(BigDecimal value) {
            addCriterion("VOUCHER_AMOUNT <>", value, "voucherAmount");
            return (Criteria) this;
        }

        public Criteria andVoucherAmountGreaterThan(BigDecimal value) {
            addCriterion("VOUCHER_AMOUNT >", value, "voucherAmount");
            return (Criteria) this;
        }

        public Criteria andVoucherAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("VOUCHER_AMOUNT >=", value, "voucherAmount");
            return (Criteria) this;
        }

        public Criteria andVoucherAmountLessThan(BigDecimal value) {
            addCriterion("VOUCHER_AMOUNT <", value, "voucherAmount");
            return (Criteria) this;
        }

        public Criteria andVoucherAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("VOUCHER_AMOUNT <=", value, "voucherAmount");
            return (Criteria) this;
        }

        public Criteria andVoucherAmountIn(List<BigDecimal> values) {
            addCriterion("VOUCHER_AMOUNT in", values, "voucherAmount");
            return (Criteria) this;
        }

        public Criteria andVoucherAmountNotIn(List<BigDecimal> values) {
            addCriterion("VOUCHER_AMOUNT not in", values, "voucherAmount");
            return (Criteria) this;
        }

        public Criteria andVoucherAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("VOUCHER_AMOUNT between", value1, value2, "voucherAmount");
            return (Criteria) this;
        }

        public Criteria andVoucherAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("VOUCHER_AMOUNT not between", value1, value2, "voucherAmount");
            return (Criteria) this;
        }

        public Criteria andLoanAmountIsNull() {
            addCriterion("LOAN_AMOUNT is null");
            return (Criteria) this;
        }

        public Criteria andLoanAmountIsNotNull() {
            addCriterion("LOAN_AMOUNT is not null");
            return (Criteria) this;
        }

        public Criteria andLoanAmountEqualTo(BigDecimal value) {
            addCriterion("LOAN_AMOUNT =", value, "loanAmount");
            return (Criteria) this;
        }

        public Criteria andLoanAmountNotEqualTo(BigDecimal value) {
            addCriterion("LOAN_AMOUNT <>", value, "loanAmount");
            return (Criteria) this;
        }

        public Criteria andLoanAmountGreaterThan(BigDecimal value) {
            addCriterion("LOAN_AMOUNT >", value, "loanAmount");
            return (Criteria) this;
        }

        public Criteria andLoanAmountGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("LOAN_AMOUNT >=", value, "loanAmount");
            return (Criteria) this;
        }

        public Criteria andLoanAmountLessThan(BigDecimal value) {
            addCriterion("LOAN_AMOUNT <", value, "loanAmount");
            return (Criteria) this;
        }

        public Criteria andLoanAmountLessThanOrEqualTo(BigDecimal value) {
            addCriterion("LOAN_AMOUNT <=", value, "loanAmount");
            return (Criteria) this;
        }

        public Criteria andLoanAmountIn(List<BigDecimal> values) {
            addCriterion("LOAN_AMOUNT in", values, "loanAmount");
            return (Criteria) this;
        }

        public Criteria andLoanAmountNotIn(List<BigDecimal> values) {
            addCriterion("LOAN_AMOUNT not in", values, "loanAmount");
            return (Criteria) this;
        }

        public Criteria andLoanAmountBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("LOAN_AMOUNT between", value1, value2, "loanAmount");
            return (Criteria) this;
        }

        public Criteria andLoanAmountNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("LOAN_AMOUNT not between", value1, value2, "loanAmount");
            return (Criteria) this;
        }

        public Criteria andStampDutyIsNull() {
            addCriterion("STAMP_DUTY is null");
            return (Criteria) this;
        }

        public Criteria andStampDutyIsNotNull() {
            addCriterion("STAMP_DUTY is not null");
            return (Criteria) this;
        }

        public Criteria andStampDutyEqualTo(BigDecimal value) {
            addCriterion("STAMP_DUTY =", value, "stampDuty");
            return (Criteria) this;
        }

        public Criteria andStampDutyNotEqualTo(BigDecimal value) {
            addCriterion("STAMP_DUTY <>", value, "stampDuty");
            return (Criteria) this;
        }

        public Criteria andStampDutyGreaterThan(BigDecimal value) {
            addCriterion("STAMP_DUTY >", value, "stampDuty");
            return (Criteria) this;
        }

        public Criteria andStampDutyGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("STAMP_DUTY >=", value, "stampDuty");
            return (Criteria) this;
        }

        public Criteria andStampDutyLessThan(BigDecimal value) {
            addCriterion("STAMP_DUTY <", value, "stampDuty");
            return (Criteria) this;
        }

        public Criteria andStampDutyLessThanOrEqualTo(BigDecimal value) {
            addCriterion("STAMP_DUTY <=", value, "stampDuty");
            return (Criteria) this;
        }

        public Criteria andStampDutyIn(List<BigDecimal> values) {
            addCriterion("STAMP_DUTY in", values, "stampDuty");
            return (Criteria) this;
        }

        public Criteria andStampDutyNotIn(List<BigDecimal> values) {
            addCriterion("STAMP_DUTY not in", values, "stampDuty");
            return (Criteria) this;
        }

        public Criteria andStampDutyBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("STAMP_DUTY between", value1, value2, "stampDuty");
            return (Criteria) this;
        }

        public Criteria andStampDutyNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("STAMP_DUTY not between", value1, value2, "stampDuty");
            return (Criteria) this;
        }

        public Criteria andInterestIsNull() {
            addCriterion("INTEREST is null");
            return (Criteria) this;
        }

        public Criteria andInterestIsNotNull() {
            addCriterion("INTEREST is not null");
            return (Criteria) this;
        }

        public Criteria andInterestEqualTo(BigDecimal value) {
            addCriterion("INTEREST =", value, "interest");
            return (Criteria) this;
        }

        public Criteria andInterestNotEqualTo(BigDecimal value) {
            addCriterion("INTEREST <>", value, "interest");
            return (Criteria) this;
        }

        public Criteria andInterestGreaterThan(BigDecimal value) {
            addCriterion("INTEREST >", value, "interest");
            return (Criteria) this;
        }

        public Criteria andInterestGreaterThanOrEqualTo(BigDecimal value) {
            addCriterion("INTEREST >=", value, "interest");
            return (Criteria) this;
        }

        public Criteria andInterestLessThan(BigDecimal value) {
            addCriterion("INTEREST <", value, "interest");
            return (Criteria) this;
        }

        public Criteria andInterestLessThanOrEqualTo(BigDecimal value) {
            addCriterion("INTEREST <=", value, "interest");
            return (Criteria) this;
        }

        public Criteria andInterestIn(List<BigDecimal> values) {
            addCriterion("INTEREST in", values, "interest");
            return (Criteria) this;
        }

        public Criteria andInterestNotIn(List<BigDecimal> values) {
            addCriterion("INTEREST not in", values, "interest");
            return (Criteria) this;
        }

        public Criteria andInterestBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("INTEREST between", value1, value2, "interest");
            return (Criteria) this;
        }

        public Criteria andInterestNotBetween(BigDecimal value1, BigDecimal value2) {
            addCriterion("INTEREST not between", value1, value2, "interest");
            return (Criteria) this;
        }

        public Criteria andImportDateIsNull() {
            addCriterion("IMPORT_DATE is null");
            return (Criteria) this;
        }

        public Criteria andImportDateIsNotNull() {
            addCriterion("IMPORT_DATE is not null");
            return (Criteria) this;
        }

        public Criteria andImportDateEqualTo(Date value) {
            addCriterionForJDBCDate("IMPORT_DATE =", value, "importDate");
            return (Criteria) this;
        }

        public Criteria andImportDateNotEqualTo(Date value) {
            addCriterionForJDBCDate("IMPORT_DATE <>", value, "importDate");
            return (Criteria) this;
        }

        public Criteria andImportDateGreaterThan(Date value) {
            addCriterionForJDBCDate("IMPORT_DATE >", value, "importDate");
            return (Criteria) this;
        }

        public Criteria andImportDateGreaterThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("IMPORT_DATE >=", value, "importDate");
            return (Criteria) this;
        }

        public Criteria andImportDateLessThan(Date value) {
            addCriterionForJDBCDate("IMPORT_DATE <", value, "importDate");
            return (Criteria) this;
        }

        public Criteria andImportDateLessThanOrEqualTo(Date value) {
            addCriterionForJDBCDate("IMPORT_DATE <=", value, "importDate");
            return (Criteria) this;
        }

        public Criteria andImportDateIn(List<Date> values) {
            addCriterionForJDBCDate("IMPORT_DATE in", values, "importDate");
            return (Criteria) this;
        }

        public Criteria andImportDateNotIn(List<Date> values) {
            addCriterionForJDBCDate("IMPORT_DATE not in", values, "importDate");
            return (Criteria) this;
        }

        public Criteria andImportDateBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("IMPORT_DATE between", value1, value2, "importDate");
            return (Criteria) this;
        }

        public Criteria andImportDateNotBetween(Date value1, Date value2) {
            addCriterionForJDBCDate("IMPORT_DATE not between", value1, value2, "importDate");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNull() {
            addCriterion("USE_STATE is null");
            return (Criteria) this;
        }

        public Criteria andUseStateIsNotNull() {
            addCriterion("USE_STATE is not null");
            return (Criteria) this;
        }

        public Criteria andUseStateEqualTo(String value) {
            addCriterion("USE_STATE =", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotEqualTo(String value) {
            addCriterion("USE_STATE <>", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThan(String value) {
            addCriterion("USE_STATE >", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateGreaterThanOrEqualTo(String value) {
            addCriterion("USE_STATE >=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThan(String value) {
            addCriterion("USE_STATE <", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLessThanOrEqualTo(String value) {
            addCriterion("USE_STATE <=", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateLike(String value) {
            addCriterion("USE_STATE like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotLike(String value) {
            addCriterion("USE_STATE not like", value, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateIn(List<String> values) {
            addCriterion("USE_STATE in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotIn(List<String> values) {
            addCriterion("USE_STATE not in", values, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateBetween(String value1, String value2) {
            addCriterion("USE_STATE between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andUseStateNotBetween(String value1, String value2) {
            addCriterion("USE_STATE not between", value1, value2, "useState");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNull() {
            addCriterion("CREATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andCreateUserIsNotNull() {
            addCriterion("CREATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andCreateUserEqualTo(String value) {
            addCriterion("CREATE_USER =", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotEqualTo(String value) {
            addCriterion("CREATE_USER <>", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThan(String value) {
            addCriterion("CREATE_USER >", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserGreaterThanOrEqualTo(String value) {
            addCriterion("CREATE_USER >=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThan(String value) {
            addCriterion("CREATE_USER <", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLessThanOrEqualTo(String value) {
            addCriterion("CREATE_USER <=", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserLike(String value) {
            addCriterion("CREATE_USER like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotLike(String value) {
            addCriterion("CREATE_USER not like", value, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserIn(List<String> values) {
            addCriterion("CREATE_USER in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotIn(List<String> values) {
            addCriterion("CREATE_USER not in", values, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserBetween(String value1, String value2) {
            addCriterion("CREATE_USER between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateUserNotBetween(String value1, String value2) {
            addCriterion("CREATE_USER not between", value1, value2, "createUser");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNull() {
            addCriterion("CREATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIsNotNull() {
            addCriterion("CREATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andCreateTimeEqualTo(Date value) {
            addCriterion("CREATE_TIME =", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotEqualTo(Date value) {
            addCriterion("CREATE_TIME <>", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThan(Date value) {
            addCriterion("CREATE_TIME >", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME >=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThan(Date value) {
            addCriterion("CREATE_TIME <", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeLessThanOrEqualTo(Date value) {
            addCriterion("CREATE_TIME <=", value, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeIn(List<Date> values) {
            addCriterion("CREATE_TIME in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotIn(List<Date> values) {
            addCriterion("CREATE_TIME not in", values, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andCreateTimeNotBetween(Date value1, Date value2) {
            addCriterion("CREATE_TIME not between", value1, value2, "createTime");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNull() {
            addCriterion("UPDATE_USER is null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIsNotNull() {
            addCriterion("UPDATE_USER is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateUserEqualTo(String value) {
            addCriterion("UPDATE_USER =", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotEqualTo(String value) {
            addCriterion("UPDATE_USER <>", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThan(String value) {
            addCriterion("UPDATE_USER >", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserGreaterThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER >=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThan(String value) {
            addCriterion("UPDATE_USER <", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLessThanOrEqualTo(String value) {
            addCriterion("UPDATE_USER <=", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserLike(String value) {
            addCriterion("UPDATE_USER like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotLike(String value) {
            addCriterion("UPDATE_USER not like", value, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserIn(List<String> values) {
            addCriterion("UPDATE_USER in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotIn(List<String> values) {
            addCriterion("UPDATE_USER not in", values, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserBetween(String value1, String value2) {
            addCriterion("UPDATE_USER between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateUserNotBetween(String value1, String value2) {
            addCriterion("UPDATE_USER not between", value1, value2, "updateUser");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNull() {
            addCriterion("UPDATE_TIME is null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIsNotNull() {
            addCriterion("UPDATE_TIME is not null");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeEqualTo(Date value) {
            addCriterion("UPDATE_TIME =", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotEqualTo(Date value) {
            addCriterion("UPDATE_TIME <>", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThan(Date value) {
            addCriterion("UPDATE_TIME >", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeGreaterThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME >=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThan(Date value) {
            addCriterion("UPDATE_TIME <", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeLessThanOrEqualTo(Date value) {
            addCriterion("UPDATE_TIME <=", value, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeIn(List<Date> values) {
            addCriterion("UPDATE_TIME in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotIn(List<Date> values) {
            addCriterion("UPDATE_TIME not in", values, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andUpdateTimeNotBetween(Date value1, Date value2) {
            addCriterion("UPDATE_TIME not between", value1, value2, "updateTime");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNull() {
            addCriterion("REMARK is null");
            return (Criteria) this;
        }

        public Criteria andRemarkIsNotNull() {
            addCriterion("REMARK is not null");
            return (Criteria) this;
        }

        public Criteria andRemarkEqualTo(String value) {
            addCriterion("REMARK =", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotEqualTo(String value) {
            addCriterion("REMARK <>", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThan(String value) {
            addCriterion("REMARK >", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkGreaterThanOrEqualTo(String value) {
            addCriterion("REMARK >=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThan(String value) {
            addCriterion("REMARK <", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLessThanOrEqualTo(String value) {
            addCriterion("REMARK <=", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkLike(String value) {
            addCriterion("REMARK like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotLike(String value) {
            addCriterion("REMARK not like", value, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkIn(List<String> values) {
            addCriterion("REMARK in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotIn(List<String> values) {
            addCriterion("REMARK not in", values, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkBetween(String value1, String value2) {
            addCriterion("REMARK between", value1, value2, "remark");
            return (Criteria) this;
        }

        public Criteria andRemarkNotBetween(String value1, String value2) {
            addCriterion("REMARK not between", value1, value2, "remark");
            return (Criteria) this;
        }
    }

    /**
     *  * cw_bd_manual_serial
     */
    public static class Criteria extends GeneratedCriteria {

        protected Criteria() {
            super();
        }
    }

    /**
     * cw_bd_manual_serial 2020-06-04
     */
    public static class Criterion {
        private String condition;

        private Object value;

        private Object secondValue;

        private boolean noValue;

        private boolean singleValue;

        private boolean betweenValue;

        private boolean listValue;

        private String typeHandler;

        public String getCondition() {
            return condition;
        }

        public Object getValue() {
            return value;
        }

        public Object getSecondValue() {
            return secondValue;
        }

        public boolean isNoValue() {
            return noValue;
        }

        public boolean isSingleValue() {
            return singleValue;
        }

        public boolean isBetweenValue() {
            return betweenValue;
        }

        public boolean isListValue() {
            return listValue;
        }

        public String getTypeHandler() {
            return typeHandler;
        }

        protected Criterion(String condition) {
            super();
            this.condition = condition;
            this.typeHandler = null;
            this.noValue = true;
        }

        protected Criterion(String condition, Object value, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.typeHandler = typeHandler;
            if (value instanceof List<?>) {
                this.listValue = true;
            } else {
                this.singleValue = true;
            }
        }

        protected Criterion(String condition, Object value) {
            this(condition, value, null);
        }

        protected Criterion(String condition, Object value, Object secondValue, String typeHandler) {
            super();
            this.condition = condition;
            this.value = value;
            this.secondValue = secondValue;
            this.typeHandler = typeHandler;
            this.betweenValue = true;
        }

        protected Criterion(String condition, Object value, Object secondValue) {
            this(condition, value, secondValue, null);
        }
    }
}